package cn.iocoder.byzs.module.aicourse.service.aiCourseType;

import cn.iocoder.byzs.framework.common.util.object.BeanUtils;
import cn.iocoder.byzs.framework.mybatis.core.query.LambdaQueryWrapperX;
import cn.iocoder.byzs.module.aicourse.controller.admin.aiCourseType.vo.AiCourseTypeListReqVO;
import cn.iocoder.byzs.module.aicourse.controller.admin.aiCourseType.vo.AiCourseTypeSaveReqVO;
import cn.iocoder.byzs.module.aicourse.dal.dataobject.aiCourseProgress.AiCourseProgressDO;
import cn.iocoder.byzs.module.aicourse.dal.dataobject.aiCourseType.AiCourseTypeDO;
import cn.iocoder.byzs.module.aicourse.dal.mysql.aiCourseProgress.AiCourseProgressMapper;
import cn.iocoder.byzs.module.aicourse.dal.mysql.aiCourseType.AiCourseTypeMapper;
import jakarta.annotation.Resource;
import org.springframework.stereotype.Service;
import org.springframework.validation.annotation.Validated;

import java.util.List;
import java.util.Objects;

import static cn.iocoder.byzs.framework.common.exception.util.ServiceExceptionUtil.exception;
import static cn.iocoder.byzs.module.aicourse.enums.ErrorCodeConstants.*;

/**
 * 课程-类型 Service 实现类
 *
 * @author lyb
 */
@Service
@Validated
public class AiCourseTypeServiceImpl implements AiCourseTypeService {

    @Resource
    private AiCourseTypeMapper aiCourseTypeMapper;
    @Resource
    private AiCourseProgressMapper aiCourseProgressMapper;

    @Override
    public Long createAiCourseType(AiCourseTypeSaveReqVO createReqVO) {
        // 校验课程类型父级id的有效性
        validateParentAiCourseType(null, createReqVO.getCtParentId());
        // 校验课程类型名称的唯一性
        validateAiCourseTypeCtTypeUnique(null, createReqVO.getCtParentId(), createReqVO.getCtType());

        // 插入
        AiCourseTypeDO blocklyType = BeanUtils.toBean(createReqVO, AiCourseTypeDO.class);
        aiCourseTypeMapper.insert(blocklyType);
        // 返回
        return blocklyType.getId();
    }

    @Override
    public void updateAiCourseType(AiCourseTypeSaveReqVO updateReqVO) {
        // 校验存在
        AiCourseTypeDO blocklyTypeDO = validateAiCourseTypeExists(updateReqVO.getId());
        // 校验课程类型父级id的有效性
        validateParentAiCourseType(updateReqVO.getId(), updateReqVO.getCtParentId());
        // 校验课程类型名称的唯一性
        validateAiCourseTypeCtTypeUnique(updateReqVO.getId(), updateReqVO.getCtParentId(), updateReqVO.getCtType());

        // 更新
        AiCourseTypeDO updateObj = BeanUtils.toBean(updateReqVO, AiCourseTypeDO.class);
        aiCourseTypeMapper.updateById(updateObj);

        // 如果修改了类型，同步更新进度数据
        if (!blocklyTypeDO.getCtTypeNode().equals("0") && !Objects.equals(updateObj.getCtParentId(), blocklyTypeDO.getCtParentId())) {

            // 使用条件更新，将brpCtId等于旧课程类型ID的记录更新为新课程类型ID
            aiCourseProgressMapper.update(new AiCourseProgressDO().setBrpZtId(updateObj.getCtParentId()),
                    new LambdaQueryWrapperX<AiCourseProgressDO>().eq(AiCourseProgressDO::getBrpZtId, blocklyTypeDO.getCtParentId()));
        }
    }

    @Override
    public void deleteAiCourseType(Long id) {
        // 校验存在
        validateAiCourseTypeExists(id);
        // 校验是否有子课程-类型
        if (aiCourseTypeMapper.selectCountByCtParentId(id) > 0) {
            throw exception(BLOCKLY_TYPE_EXITS_CHILDREN);
        }
        // 删除
        aiCourseTypeMapper.deleteById(id);
    }


    private AiCourseTypeDO validateAiCourseTypeExists(Long id) {
        AiCourseTypeDO blocklyTypeDO = aiCourseTypeMapper.selectById(id);
        if (blocklyTypeDO == null) {
            throw exception(BLOCKLY_TYPE_NOT_EXISTS);
        }
        return blocklyTypeDO;
    }

    private void validateParentAiCourseType(Long id, Long ctParentId) {
        if (ctParentId == null || AiCourseTypeDO.CT_PARENT_ID_ROOT.equals(ctParentId)) {
            return;
        }
        // 1. 不能设置自己为父课程-类型
        if (Objects.equals(id, ctParentId)) {
            throw exception(BLOCKLY_TYPE_PARENT_ERROR);
        }
        // 2. 父课程-类型不存在
        AiCourseTypeDO parentAiCourseType = aiCourseTypeMapper.selectById(ctParentId);
        if (parentAiCourseType == null) {
            throw exception(BLOCKLY_TYPE_PARENT_NOT_EXITS);
        }
        // 3. 递归校验父课程-类型，如果父课程-类型是自己的子课程-类型，则报错，避免形成环路
        if (id == null) { // id 为空，说明新增，不需要考虑环路
            return;
        }
        for (int i = 0; i < Short.MAX_VALUE; i++) {
            // 3.1 校验环路
            ctParentId = parentAiCourseType.getCtParentId();
            if (Objects.equals(id, ctParentId)) {
                throw exception(BLOCKLY_TYPE_PARENT_IS_CHILD);
            }
            // 3.2 继续递归下一级父课程-类型
            if (ctParentId == null || AiCourseTypeDO.CT_PARENT_ID_ROOT.equals(ctParentId)) {
                break;
            }
            parentAiCourseType = aiCourseTypeMapper.selectById(ctParentId);
            if (parentAiCourseType == null) {
                break;
            }
        }
    }

    private void validateAiCourseTypeCtTypeUnique(Long id, Long ctParentId, String ctType) {
        AiCourseTypeDO blocklyType = aiCourseTypeMapper.selectByCtParentIdAndCtType(ctParentId, ctType);
        if (blocklyType == null) {
            return;
        }
        // 如果 id 为空，说明不用比较是否为相同 id 的课程-类型
        if (id == null) {
            throw exception(BLOCKLY_TYPE_CT_TYPE_DUPLICATE);
        }
        if (!Objects.equals(blocklyType.getId(), id)) {
            throw exception(BLOCKLY_TYPE_CT_TYPE_DUPLICATE);
        }
    }

    @Override
    public AiCourseTypeDO getAiCourseType(Long id) {
        return aiCourseTypeMapper.selectById(id);
    }

    @Override
    public List<AiCourseTypeDO> getAiCourseTypeList(AiCourseTypeListReqVO listReqVO) {
        return aiCourseTypeMapper.selectList(listReqVO);
    }

    @Override
    public List<AiCourseTypeDO> getAiCourseTypeSimpleList(AiCourseTypeListReqVO listReqVO) {
        return aiCourseTypeMapper.selectSimpleList(listReqVO);
    }

}